// Output from p2c 1.21alpha-07.Dec.93, the Pascal-to-C translator
// From input file "arma.pas"


//#include <p2c/p2c.h>
#include <mathe1.h>
#include <mathe2.h>
#include <mathe4.h>
#include <arma.h>
#include <iostream>

#include <cmath>

// static variables for armaacf:
struct LOC_armaacf {
	int p, q;
	double* rex, *ai, *bi;
} ;

static double
det(double* asub, int n, struct LOC_armaacf *LINK)
{
    TRACE("det(...)");
	double s = 0.0;

	if (n == 1) {
		return (asub[0]);
	}
	double* asubsub = new double[(n - 1) * (n - 1)];
	for (int i = 0; i < n; ++i) {
		for (int j = 0; j < i; ++j) {
		for (int k = 0; k <= n - 2; ++k) {
		asubsub[(n - 1) * k + j] = asub[n * (k + 1) + j];
		}
		}
		for (int j = i; j <= n - 2; ++j) {
		for (int k = 0; k <= n - 2; ++k) {
		asubsub[(n - 1) * k + j] = asub[n * (k + 1) + j + 1];
		}
		}
		if ((i & 1) == 0) {
		s += asub[i] * det(asubsub, n - 1, LINK);
		}
		if ((i & 1) == 1) {
		s -= asub[i] * det(asubsub, n - 1, LINK);
		}
	}
	double Result = s;
// p2c: arma.pas, line 38: Warning: Too many arguments for freemem [299]
	delete [] asubsub;
	return Result;
}

// static double
// smod0(struct LOC_armaacf *LINK)
// {
// 	int FORLIM = LINK->p;
// 	double* suba = new double[(LINK->p + 1) * (LINK->p + 1)];
// 	for (int j = 0; j <= FORLIM; ++j) {
// 		int FORLIM1 = LINK->p;
// 		for (int i = 0; i <= FORLIM1; ++i) {
// 		suba[j * (LINK->p + 1) + i] = 0.0;
// 		}
// 	}
// 
// 	FORLIM = LINK->p;
// 	for (int j = 0; j <= FORLIM; ++j) {
// 		int FORLIM1 = LINK->p;
// 		for (int i = 0; i <= FORLIM1; ++i) {
// 		suba[j * (LINK->p + 1) + abs(j - i)] += LINK->ai[i];
// 		}
// 	}
// 	double Result = det(suba, LINK->p + 1, LINK);
// 	delete [] suba;
// 	return Result;
// }

static double 
mod0(struct LOC_armaacf *LINK)
{
    TRACE("mod0(.)");
	int FORLIM = LINK->p;
	double* suba = new double[(LINK->p + 1) * (LINK->p + 1)];
	for (int j = 0; j <= FORLIM; ++j) {
		int FORLIM1 = LINK->p;
		for (int i = 0; i <= FORLIM1; ++i) {
		suba[j * (LINK->p + 1) + i] = 0.0;
		}
	}      
	FORLIM = LINK->p;
	for (int j = 0; j <= FORLIM; ++j) {
		int FORLIM1 = LINK->p;
		for (int i = 0; i <= FORLIM1; ++i) {
		suba[j * (LINK->p + 1) + abs(j - i)] += LINK->ai[i];
		}
	}
	double Result = det(suba, LINK->p + 1, LINK);
	delete [] suba;
	return Result;
}

static double
modk(int k, struct LOC_armaacf *LINK)
{
    TRACE("modk(..)");
	int FORLIM = LINK->p;
	double* suba = new double[(LINK->p + 1) * (LINK->p + 1)];
	for (int j = 0; j <= FORLIM; ++j) {
		int FORLIM1 = LINK->p;
		for (int i = 0; i <= FORLIM1; ++i) {
		suba[j * (LINK->p + 1) + i] = 0.0;
		}
	}

	FORLIM = LINK->p;
	for (int j = 0; j <= FORLIM; ++j) {
		int FORLIM1 = LINK->p;
		for (int i = 0; i <= FORLIM1; ++i) {
		suba[j * (LINK->p + 1) + abs(j - i)] += LINK->ai[i];
		}
	}
	FORLIM = LINK->p;
	for (int j = 0; j <= FORLIM; ++j) {
		suba[j * (LINK->p + 1) + k] = 0.0;
	}
	FORLIM = LINK->p;
	for (int j = 0; j <= FORLIM; ++j) {
		int FORLIM1 = LINK->q;
		for (int i = j; i <= FORLIM1; ++i) {
		suba[j * (LINK->p + 1) + k] += LINK->bi[i] * LINK->rex[i - j];
		}
	}
	double Result = det(suba, LINK->p + 1, LINK);
// p2c: arma.pas, line 64: Warning: Too many arguments for freemem [299]
	delete [] suba;
	return Result;
}

static int
maxi_(int x, int y, struct LOC_armaacf *LINK)
{
    TRACE("maxi_(...)");
	if (x > y) {
		return x;
	} else {
		return y;
	}
}

static int
mini_(int x, int y, struct LOC_armaacf *LINK)
{
    TRACE("mini_(...)");
	if (x < y) {
		return x;
	} else {
		return y;
	}
}


void
armaacf(int p_, double* a, int q_, double* b, int k, double* ryyn,
		double* reyn)
{
    TRACE("armaacf(.......)");
	struct LOC_armaacf V;
	double dum = 0.0;

	V.p = p_;
	V.q = q_;
	V.rex = new double[maxi_(k, V.q + 1, &V)];
	V.ai = new double[(V.p + 1)];
	V.bi = new double[(V.q + 1)];
	int FORLIM = V.p;
	for (int i = 0; i <= FORLIM; ++i) {
		V.ai[i] = a[i] / a[0];
	}
	FORLIM = V.q;
	for (int i = 0; i <= FORLIM; ++i) {
		V.bi[i] = b[i] / a[0];
	}
	FORLIM = maxi_(k - 1, V.q, &V);
	for (int i = 0; i <= FORLIM; ++i) {
		if (dum < 1e6) {
		V.rex[i] = 0.0;
		int FORLIM1 = mini_(V.p, i, &V);
		for (int j = 1; j <= FORLIM1; ++j) {
		V.rex[i] -= V.ai[j] * V.rex[i - j];
		}
		if (i <= V.q) {
		V.rex[i] += V.bi[i];
		}
		dum = fabs(V.rex[i]);
		}
	}
	if (dum >= 1e6) {
		FORLIM = maxi_(k - 1, V.q, &V);
		for (int i = 0; i <= FORLIM; ++i) {
		V.rex[i] = 0.0;
		}
	}
	double d0 = mod0(&V);
	if (d0 != 0) {
		FORLIM = mini_(V.p, k - 1, &V);
		for (int i = 0; i <= FORLIM; ++i) {
		ryyn[i] = modk(i, &V) / d0;
		}
	} else {
		FORLIM = mini_(V.p, k - 1, &V);
		for (int i = 0; i <= FORLIM; ++i) {
		ryyn[i] = 0.0;
		}
	}
	if (ryyn != NULL) {
	    int  i;
		for (i = V.p + 1; i < k; ++i) {
		ryyn[i] = 0.0;
		int FORLIM1 = V.p;
		for (int j = 1; j <= FORLIM1; ++j) {
		ryyn[i] -= V.ai[j] * ryyn[i - j];
		}
		FORLIM1 = V.q;
		for (int j = i; j <= FORLIM1; ++j) {
		ryyn[i] += V.bi[j] * V.rex[j - i];
		}
		}
	}
	if (reyn != NULL) {
		for (int i = 0; i < k; ++i) {
		reyn[i] = V.rex[i];
		}
	}
	delete [] V.rex;
	delete [] V.ai;
	delete [] V.bi;
}


void
armaspc(int p, double* a, int q, double* b, int k, double* fn, double* sn)
{
    TRACE("armaspc(.......)");
	tcomplex z, n;
	for (int i = 0; i < k; ++i) {
		z.re = 0.0;
		z.im = 0.0;
		n.re = 0.0;
		n.im = 0.0;
		for (int j = 0; j <= q; ++j) {
		z.re += b[j] * cos(2 * M_PI * j * fn[i]);
		z.im += b[j] * sin(2 * M_PI * j * fn[i]);
		}
		for (int j = 0; j <= p; ++j) {
		n.re += a[j] * cos(2 * M_PI * j * fn[i]);
		n.im += a[j] * sin(2 * M_PI * j * fn[i]);
		}
		if (n.re * n.re + n.im * n.im > 0) {
		sn[i] = (z.re * z.re + z.im * z.im) / (n.re * n.re + n.im * n.im);
		} else {
		sn[i] = 0.0;
		}
	}
}

// End.
