// From input file "bm3.pas"
// $Id: bm3.h,v 1.2 2004/09/01 12:45:28 micheli Exp $
// utilities for bm3

#include <common.h>
#include <cstdio>
#include <iostream>

using namespace std;

// static variables for run:
typedef struct LOC_run {
    size_t spect_type;      //!< Spectral type
    size_t bias_type;       //!< Bias type
    size_t sig_group;       //!< signal group
    size_t num_sandseed;    //!< number to use to seed random generator

    // file names and streams
    char out_file_basename[256]; //!< base name of the result file
	char psf_NAME[_FNSIZE]; //!< name of
	FILE* psf;              //!< stream wheure the generated values are written
	time_t oldmeldetime;    //! date of last progress display

    // arma model
    double prim_freq;   //!< primary frequency
    size_t p;           //!< order of polynome aa AR-Coefficients
    double* aa;         //!< coefficient a of the arma model
	double* ee;         //!< 
    size_t q;           //!< order of polynome bb MA-Coefficients
    double* bb;         //!< coefficient b of the arma model
    double* yy;         //!< 

    size_t psn;         //!< Number of Samples
    double mean;        //!< Mean Velocity
//    double vvar;        //!< Velocity Variance
    double dotn;        //!< Particle Rate
    double dtm;         //!< 1./Particle Rate (sort of average TBD)
    double sqrtnoise;   //!< sqrt(Noise Power)
    double quer;        //!< Cross Velocity
    
    bool bias;

    double del;         //!< Processor Delay
    double del0;        //!<
    bool vosc;          //!< Oscillations ?
    double oscamp;      //!< Osc. Amplitude
    double oscper;      //!< Osc. Periode
    bool vvdn;          //!< Varying Data Rate ?
    double vdnfac;      //!< Rate Ratio
    double vdnper;      //!< Periode of Varying Data Rate
    bool vdro;          //!< Drop Outs ?
    double drofac;      //!< Time Ratio factor
    double droper;      //!< Drop out Periode
    
    double pper;        //!< 
    
    double psto;        //!< measurement date
    double pst;
    double pstto;       //!< transit time
    double pstt;
    double psuo;        //!< velocity
    double psu;
    bool psvo;
    bool psv;
    
    double tsto;
	double tst;
    double gsto;
    double gst;
    double gsuo;
    double gsu;
    double tsuo;
    double tsu;
    
    double gss;
    double ees;
    double dsm;
    double vv;
    double tsx;
    size_t psc;
    int gsc;
    int tsc;
};

//! usage 
void help();
//! write the value of i in Result or "random" if i==0 
char * sreal(char* Result, int i);
//! write the value of x in Result or "none" if x==0 
char * snone(char* Result, double x);
//! write yes or no in Result following  x==0 
char * sbool(char* Result, bool v);
//! display progress
void meldung(double x, bool overwrite, LOC_run& V);
//! write coeffcienst of the arma model
void write_cof(const char* out_file_basename, const LOC_run& V);
//! Display analysis results
void info(const LOC_run& V, ostream& s = cout);
