// Output from p2c 1.21alpha-07.Dec.93, the Pascal-to-C translator
// From input file "fourier.pas"
#define FOURIER_G
#include <mathe1.h>
#include <mathe2.h>
#include <fourier.h>
#include <cmath>
#include <iostream>

static void
conv(tcomplex& ca, tcomplex& cb, tcomplex ce)
{
    // TRACE("conv(...)");
	tcomplex ct, cv, ch;
	multcc(ce, cb, ct);
	multsc(0.5, ct, ch);
	multsc(0.5, ca, cv);
	addcc(cv, ch, ca);
	subcc(cv, ch, cb);
}

static int
exchw(int i, int s)
{
    // TRACE("exchw(..)");
	int o = 0;
	for (int r = 0; r <= s - 2; ++r) {
		o += i & 1;
		i = ((unsigned)i) >> 1;
		o <<= 1;
	}
	o += i & 1;
	return o;
}

static void
umsort(tcomplex* xfft, int s)
{
    // TRACE("umsort(..)");
	int FORLIM = int(floor(exp(s * log(2.0)) + 0.5));
	for (int r = 0; r < FORLIM; ++r) {
		int ri = exchw(r, s);
		if (ri > r) {
		tcomplex xfftt = xfft[r];
		xfft[r] = xfft[ri];
		xfft[ri] = xfftt;
		}
	}
}

static void
fft(tcomplex* xfft, int n)
{
    // TRACE("fft(..)");
	tcomplex ce, cei;
	int k = int(floor(log(n) / log(2.0) + 0.5));
	k = int(floor(exp(k * log(2.0)) + 0.5));
	if (k != n) {
		ft(xfft, n);
		return;
	}
	int s = int(floor(log(n) / log(2.0) + 0.5));
	for (int r = s; r >= 1; --r) {
		int q = int(floor(exp((r - 1) * log(2.0)) + 0.5));
		int p = int(floor(exp((s - r) * log(2.0)) + 0.5));
		for (int j = 0; j < p; ++j) {
		int shft = exchw(j, s - r + 1) * q;
		setcomplex(0.0, -(j * M_PI / p), cei);
		expc(cei, ce);
		for (k = 0; k < q; ++k) {
		conv(xfft[k + shft], xfft[k + shft + q], ce);
		}
		}
	}
	umsort(xfft, s);
	for (int r = 0; r < n; ++r) {
		xfft[r].re = n * xfft[r].re;
	}
	for (int r = 0; r < n; ++r) {
		xfft[r].im = n * xfft[r].im;
	}
}

static void
ifft(tcomplex* xfft, int n)
{
    // TRACE("ifft(..)");
	tcomplex ce, cei;
	int k = int(floor(log(n) / log(2.0) + 0.5));
	k = int(floor(exp(k * log(2.0)) + 0.5));
	if (k != n) {
		ift(xfft, n);
		return;
	}
	int s = int(floor(log(n) / log(2.0) + 0.5));
	for (int r = s; r >= 1; --r) {
		int q = int(floor(exp((r - 1) * log(2.0)) + 0.5));
		int p = int(floor(exp((s - r) * log(2.0)) + 0.5));
		for (int j = 0; j < p; ++j) {
		int shft = exchw(j, s - r + 1) * q;
		setcomplex(0.0, j * M_PI / p, cei);
		expc(cei, ce);
		for (k = 0; k < q; ++k) {
		conv(xfft[k + shft], xfft[k + shft + q], ce);
		}
		}
	}
	umsort(xfft, s);
}

// static void
// dft(tcomplex* xfft, int n)
// {
// 	tcomplex* yfft = new tcomplex[n];
// 	tcomplex* cosi = new tcomplex[n];
// 	for (int i = 0; i < n; ++i) {
// 		cosi[i].re = cos(-2 * M_PI * i / n);
// 	}
// 	for (int i = 0; i < n; ++i) {
// 		cosi[i].im = sin(-2 * M_PI * i / n);
// 	}
// 	for (int i = 0; i < n; ++i) {
// 		yfft[i].re = 0.0;
// 	}
// 	for (int i = 0; i < n; ++i) {
// 		yfft[i].im = 0.0;
// 	}
// 	for (int i = 0; i < n; ++i) {
// 		for (int j = 0; j < n; ++j) {
// 		yfft[i].re +=
// 		  xfft[j].re * cosi[i * j % n].re - xfft[j].im * cosi[i * j % n].im;
// // p2c: fourier.pas, line 138:
// // * Note: Using % for possibly-negative arguments [317]
// // p2c: fourier.pas, line 138:
// // * Note: Using % for possibly-negative arguments [317]
// 		}
// 	}
// 	for (int i = 0; i < n; ++i) {
// 		for (int j = 0; j < n; ++j) {
// 		yfft[i].im += xfft[j].re * cosi[i * j % n].im +
// 					  xfft[j].im * cosi[i * j % n].re;
// // p2c: fourier.pas, line 140:
// // * Note: Using % for possibly-negative arguments [317]
// // p2c: fourier.pas, line 140:
// // * Note: Using % for possibly-negative arguments [317]
// 		}
// 	}
// 	for (int i = 0; i < n; ++i) {
// 		xfft[i].re = yfft[i].re;
// 	}
// 	for (int i = 0; i < n; ++i) {
// 		xfft[i].im = yfft[i].im;
// 	}
// // p2c: fourier.pas, line 143:
// // * Warning: Too many arguments for freemem [299]
// 	delete [] yfft;
// // p2c: fourier.pas, line 144:
// // * Warning: Too many arguments for freemem [299]
// 	delete [] cosi;
// }
// 
// static void
// idft(tcomplex* xfft, int n)
// {
// 	tcomplex* yfft = new tcomplex[n];
// 	tcomplex* cosi = new tcomplex[n];
// 	for (int i = 0; i < n; ++i) {
// 		cosi[i].re = cos(2 * M_PI * i / n);
// 	}
// 	for (int i = 0; i < n; ++i) {
// 		cosi[i].im = sin(2 * M_PI * i / n);
// 	}
// 	for (int i = 0; i < n; ++i) {
// 		yfft[i].re = 0.0;
// 	}
// 	for (int i = 0; i < n; ++i) {
// 		yfft[i].im = 0.0;
// 	}
// 	for (int i = 0; i < n; ++i) {
// 		for (int j = 0; j < n; ++j) {
// 		yfft[i].re +=
// 		  xfft[j].re * cosi[i * j % n].re - xfft[j].im * cosi[i * j % n].im;
// // p2c: fourier.pas, line 159:
// // * Note: Using % for possibly-negative arguments [317]
// // p2c: fourier.pas, line 159:
// // * Note: Using % for possibly-negative arguments [317]
// 		}
// 	}
// 	for (int i = 0; i < n; ++i) {
// 		for (int j = 0; j < n; ++j) {
// 		yfft[i].im += xfft[j].re * cosi[i * j % n].im +
// 					  xfft[j].im * cosi[i * j % n].re;
// // p2c: fourier.pas, line 161:
// // * Note: Using % for possibly-negative arguments [317]
// // p2c: fourier.pas, line 161:
// // * Note: Using % for possibly-negative arguments [317]
// 		}
// 	}
// 	for (int i = 0; i < n; ++i) {
// 		xfft[i].re = yfft[i].re / n;
// 	}
// 	for (int i = 0; i < n; ++i) {
// 		xfft[i].im = yfft[i].im / n;
// 	}
// // p2c: fourier.pas, line 164:
// // * Warning: Too many arguments for freemem [299]
// 	delete [] yfft;
// // p2c: fourier.pas, line 165:
// // * Warning: Too many arguments for freemem [299]
// 	delete [] cosi;
// }

static void
ft_kern(tcomplex* xfft, int n, int m, tcomplex* w)
{
    // TRACE("ft_kern(....)");
	int ni = 2;
	tcomplex* a, *y;
	tcomplex ci;
	if (n <= 1) {
		return;
	}
	while (n % ni > 0) {
		++ni;
	}
// p2c: fourier.pas, line 176:
// * Note: Using % for possibly-negative arguments [317]
	int t = n / ni;
	y = new tcomplex[n];
	a = new tcomplex[t];
	for (int i = 0; i < n; ++i) {
		y[i].re = 0.0;
	}
	for (int i = 0; i < n; ++i) {
		y[i].im = 0.0;
	}
	for (int j = 0; j < ni; ++j) {
		for (int i = 0; i < t; ++i) {
		a[i] = xfft[i * ni + j];
		}
		ft_kern(a, t, ni * m, w);
		for (int k = 0; k < ni; ++k) {
		for (int i = 0; i < t; ++i) {
// p2c: fourier.pas, line 188:
// * Note: Using % for possibly-negative arguments [317]
		multcc(w[j * (i + t * k) % n * m], a[i], ci);
		addcc(y[i + k * t], ci, y[i + k * t]);
		}
		}
	}
	for (int i = 0; i < n; ++i) {
		xfft[i].re = y[i].re;
	}
	for (int i = 0; i < n; ++i) {
		xfft[i].im = y[i].im;
	}
	delete [] a;
	delete [] y;
}

void
ft(tcomplex* xfft, int n)
{
    // TRACE("ft(..)");
	int i = int(floor(log(n) / log(2.0) + 0.5));
	i = int(floor(exp(i * log(2.0)) + 0.5));
	if (i == n) {
		fft(xfft, n);
		return;
	}
	tcomplex* w = new tcomplex[n];
	for (int i = 0; i < n; ++i) {
		w[i].re = cos(-2 * M_PI * i / n);
	}
	for (int i = 0; i < n; ++i) {
		w[i].im = sin(-2 * M_PI * i / n);
	}
	ft_kern(xfft, n, 1, w);
	delete[] w;
}

void
ift(tcomplex* xfft, int n)
{
    // TRACE("ift(..)");
	int i = int(floor(log(n) / log(2.0) + 0.5));
	i = int(floor(exp(i * log(2.0)) + 0.5));
	if (i == n) {
		ifft(xfft, n);
		return;
	}
    
	tcomplex* w = new tcomplex[n];
	for (i = 0; i < n; ++i) {
		w[i].re = cos(2 * M_PI * i / n);
	}
	for (i = 0; i < n; ++i) {
		w[i].im = sin(2 * M_PI * i / n);
	}
	ft_kern(xfft, n, 1, w);
	for (i = 0; i < n; ++i) {
		xfft[i].re /= n;
	}
	for (i = 0; i < n; ++i) {
		xfft[i].im /= n;
	}
	delete[] w;
}

static void
eumsort(tcomplex** xfft, int s)
{
    // TRACE("eumsort(..)");
    int FORLIM = int(floor(exp(s * log(2.0)) + 0.5));
	for (int r = 0; r < FORLIM; ++r) {
		int ri = exchw(r, s);
		if (ri > r) {
		tcomplex xfftt = xfft[r / mfourier][r % mfourier];
// p2c: fourier.pas, line 246:
// * Note: Using % for possibly-negative arguments [317]
		xfft[r / mfourier][r % mfourier] = xfft[ri / mfourier][ri % mfourier];
// p2c: fourier.pas, line 247:
// * Note: Using % for possibly-negative arguments [317]
// p2c: fourier.pas, line 247:
// * Note: Using % for possibly-negative arguments [317]
		xfft[ri / mfourier][ri % mfourier] = xfftt;
// p2c: fourier.pas, line 248:
// * Note: Using % for possibly-negative arguments [317]
		}
	}
}

static void
efft(tcomplex** xfft, int n)
{
    // TRACE("efft(..)");
	tcomplex ce, cei;
	int k = int(floor(log(n) / log(2.0) + 0.5));
	k = int(floor(exp(k * log(2.0)) + 0.5));
	if (k != n) {
		eft(xfft, n);
		return;
	}
	int s = int(floor(log(n) / log(2.0) + 0.5));
	for (int r = s; r >= 1; --r) {
		int q = int(floor(exp((r - 1) * log(2.0)) + 0.5));
		int p = int(floor(exp((s - r) * log(2.0)) + 0.5));
		for (int j = 0; j < p; ++j) {
		int shft = exchw(j, s - r + 1) * q;
		setcomplex(0.0, -(j * M_PI / p), cei);
		expc(cei, ce);
		for (k = 0; k < q; ++k) {
// p2c: fourier.pas, line 274:
// * Note: Using % for possibly-negative arguments [317]
// p2c: fourier.pas, line 275:
// * Note: Using % for possibly-negative arguments [317]
		conv(xfft[(k + shft) / mfourier]
			 [(k + shft) % mfourier], xfft[(k + shft + q) / mfourier]
			 [(k + shft + q) % mfourier], ce);
		}
		}
	}
	eumsort(xfft, s);
	for (int r = 0; r < n; ++r) {
		setppfourier(xfft, r, n * getppfourierre(xfft, r),
					 n * getppfourierim(xfft, r));
	}
}

static void
eifft(tcomplex** xfft, int n)
{
    // TRACE("eifft(..)");
	tcomplex ce, cei;
	int k = int(floor(log(n) / log(2.0) + 0.5));
	k = int(floor(exp(k * log(2.0)) + 0.5));
	if (k != n) {
		eift(xfft, n);
		return;
	}
	int s = int(floor(log(n) / log(2.0) + 0.5));
	for (int r = s; r >= 1; --r) {
		int q = int(floor(exp((r - 1) * log(2.0)) + 0.5));
		int p = int(floor(exp((s - r) * log(2.0)) + 0.5));
		for (int j = 0; j < p; ++j) {
		int shft = exchw(j, s - r + 1) * q;
		setcomplex(0.0, j * M_PI / p, cei);
		expc(cei, ce);
		for (k = 0; k < q; ++k) {
// p2c: fourier.pas, line 304:
// * Note: Using % for possibly-negative arguments [317]
// p2c: fourier.pas, line 305:
// * Note: Using % for possibly-negative arguments [317]
		conv(xfft[(k + shft) / mfourier]
			 [(k + shft) % mfourier], xfft[(k + shft + q) / mfourier]
			 [(k + shft + q) % mfourier], ce);
		}
		}
	}
	eumsort(xfft, s);
	for (int r = 0; r < n; ++r) {
		setppfourier(xfft, r, getppfourierre(xfft, r),
					 getppfourierim(xfft, r));
	}
}

// static void
// edft(tcomplex** xfft, int n)
// {
// 	tcomplex** yfft, **cosi;
// 	getppfouriermem(yfft, n);
// 	getppfouriermem(cosi, n);
// 	for (int i = 0; i < n; ++i) {
// 		setppfourier(cosi, i, cos(-2 * M_PI * i / n), sin(-2 * M_PI * i / n));
// 	}
// 	for (int i = 0; i < n; ++i) {
// 		setppfourier(yfft, i, 0.0, 0.0);
// 	}
// 	for (int i = 0; i < n; ++i) {
// 		for (int j = 0; j < n; ++j) {
// // p2c: fourier.pas, line 324:
// // * Note: Using % for possibly-negative arguments [317]
// // p2c: fourier.pas, line 325:
// // * Note: Using % for possibly-negative arguments [317]
// // p2c: fourier.pas, line 326:
// // * Note: Using % for possibly-negative arguments [317]
// // p2c: fourier.pas, line 327:
// // * Note: Using % for possibly-negative arguments [317]
// 		incppfourier(yfft,
// 		  i, getppfourierre(xfft, j) * getppfourierre(cosi, i * j % n) -
// 			 getppfourierim(xfft, j) * getppfourierim(cosi, i * j % n),
// 		  getppfourierre(xfft, j) * getppfourierim(cosi, i * j % n) +
// 		  getppfourierim(xfft, j) * getppfourierre(cosi, i * j % n));
// 		}
// 	}
// 	for (int i = 0; i < n; ++i) {
// 		setppfourier(xfft, i, getppfourierre(yfft, i),
// 					 getppfourierim(yfft, i));
// 	}
// 	freeppfouriermem(yfft, n);
// 	freeppfouriermem(cosi, n);
// }
// 
// static void
// eidft(tcomplex** xfft, int n)
// {
// 	tcomplex** yfft, **cosi;
// 	getppfouriermem(yfft, n);
// 	getppfouriermem(cosi, n);
// 	for (int i = 0; i < n; ++i) {
// 		setppfourier(cosi, i, cos(2 * M_PI * i / n), sin(2 * M_PI * i / n));
// 	}
// 	for (int i = 0; i < n; ++i) {
// 		setppfourier(yfft, i, 0.0, 0.0);
// 	}
// 	for (int i = 0; i < n; ++i) {
// 		for (int j = 0; j < n; ++j) {
// // p2c: fourier.pas, line 344:
// // * Note: Using % for possibly-negative arguments [317]
// // p2c: fourier.pas, line 345:
// // * Note: Using % for possibly-negative arguments [317]
// // p2c: fourier.pas, line 346:
// // * Note: Using % for possibly-negative arguments [317]
// // p2c: fourier.pas, line 347:
// // * Note: Using % for possibly-negative arguments [317]
// 		incppfourier(yfft,
// 		  i, getppfourierre(xfft, j) * getppfourierre(cosi, i * j % n) -
// 			 getppfourierim(xfft, j) * getppfourierim(cosi, i * j % n),
// 		  getppfourierre(xfft, j) * getppfourierim(cosi, i * j % n) +
// 		  getppfourierim(xfft, j) * getppfourierre(cosi, i * j % n));
// 		}
// 	}
// 	for (int i = 0; i < n; ++i) {
// 		setppfourier(xfft, i, getppfourierre(yfft, i) / n,
// 					 getppfourierim(yfft, i) / n);
// 	}
// 	freeppfouriermem(yfft, n);
// 	freeppfouriermem(cosi, n);
// }

static void
eft_kern(tcomplex** xfft, int n, int m, tcomplex** w)
{
    // TRACE("eft_kern(....)");
	int ni = 2;
	tcomplex** a, **y;
	tcomplex ci, wi, ai;
	if (n <= 1) {
		return;
	}
	while (n % ni > 0) {
		++ni;
	}
// p2c: fourier.pas, line 361:
// * Note: Using % for possibly-negative arguments [317]
	int t = n / ni;
	getppfouriermem(y, n);
	getppfouriermem(a, t);
	for (int i = 0; i < n; ++i) {
		setppfourier(y, i, 0.0, 0.0);
	}
	for (int j = 0; j < ni; ++j) {
		for (int i = 0; i < t; ++i) {
		setppfourier(a, i, getppfourierre(xfft, i * ni + j),
					 getppfourierim(xfft, i * ni + j));
		}
		eft_kern(a, t, ni * m, w);
		for (int k = 0; k < ni; ++k) {
			for (int i = 0; i < t; ++i) {
	// p2c: fourier.pas, line 372:
	// * Note: Using % for possibly-negative arguments [317]
	// p2c: fourier.pas, line 372:
	// * Note: Using % for possibly-negative arguments [317]
			setcomplex(getppfourierre(w, j * (i + t * k) % n * m),
					   getppfourierim(w, j * (i + t * k) % n * m), wi);
			setcomplex(getppfourierre(a, i), getppfourierim(a, i), ai);
			multcc(wi, ai, ci);
			incppfourier(y, i + k * t, ci.re, ci.im);
			}
		}
	}
	for (int i = 0; i < n; ++i) {
		setppfourier(xfft, i, getppfourierre(y, i), getppfourierim(y, i));
	}
	freeppfouriermem(a, t);
	freeppfouriermem(y, n);
}

void
eft(tcomplex** xfft, int n)
{
    // TRACE("eft(..)");
	tcomplex** w;
	int i = int(floor(log(n) / log(2.0) + 0.5));
	i = int(floor(exp(i * log(2.0)) + 0.5));
	if (i == n) {
		efft(xfft, n);
		return;
	}
	getppfouriermem(w, n);
	for (i = 0; i < n; ++i) {
		setppfourier(w, i, cos(-2 * M_PI * i / n), sin(-2 * M_PI * i / n));
	}
	eft_kern(xfft, n, 1, w);
	freeppfouriermem(w, n);
}

void
eift(tcomplex** xfft, int n)
{
    // TRACE("eift(..)");
	tcomplex** w;
	int i = int(floor(log(n) / log(2.0) + 0.5));
	i = int(floor(exp(i * log(2.0)) + 0.5));
	if (i == n) {
		eifft(xfft, n);
		return;
	}
	getppfouriermem(w, n);
	for (i = 0; i < n; ++i) {
		setppfourier(w, i, cos(2 * M_PI * i / n), sin(2 * M_PI * i / n));
	}
	eft_kern(xfft, n, 1, w);
	for (i = 0; i < n; ++i) {
		setppfourier(xfft, i, getppfourierre(xfft, i) / n,
					 getppfourierim(xfft, i) / n);
	}
	freeppfouriermem(w, n);
}

// End.
