// Output from p2c 1.21alpha-07.Dec.93, the Pascal-to-C translator
// From input file "hilbert.pas"

//#include <p2c/p2c.h>

#include <mathe1.h>
#include <mathe2.h>
#include <hilbert.h>
#include <fourier.h>
#include <cstring>
#include <iostream>

// p2c: hilbert.pas, line 12: Warning: Could not find module SPLUS [271] 
//#include <splus.h>

void
ht(char* kind_, tcomplex* xfht, size_t n)
{
    TRACE("ht(...)");
	char kind[256];
	tcomplex cm;
	// char STR1[256];

	strcpy(kind, downstring(kind_));
	bool t = (kind[1] == 't');
	bool f = (kind[1] == 'f');
	bool a = (kind[1] == 'a');
	bool r = (kind[1] == 'r');
	if (!(strlen(kind) == 2 && (t || f) && (a || r))) {
		printf("use ht(s,a,n) with s=[at|rt|af|rf]\n");
		return;
	}
	if (t) {
		ft(xfht, n);
	}
	for (size_t i = 0; i < n; ++i) {
		//
		//      if r and ((2*i) mod n=0)     then setcomplex(0,0,cm);
		//      if r and (2*i>0) and (2*i<n) then setcomplex(xfht^[i].im,-xfht^[i].re,cm);
		//      if r and (2*i>n)             then setcomplex(-xfht^[i].im,xfht^[i].re,cm);
		//      if a and ((2*i) mod n=0)     then setcomplex(xfht^[i].re,xfht^[i].im,cm);
		//      if a and (2*i>0) and (2*i<n) then setcomplex(2*xfht^[i].re,2*xfht^[i].im,cm);
		//      if a and (2*i>n)             then setcomplex(0,0,cm);
		//
		if (r && (i * 2) < n) {
		  setcomplex(xfht[i].im, -xfht[i].re, cm);
		}
		if (r && i * 2 >= n) {
		  setcomplex(-xfht[i].im, xfht[i].re, cm);
		}
		if (a && (i * 2) < n) {
		  setcomplex(2 * xfht[i].re, 2 * xfht[i].im, cm);
		}
		if (a && i * 2 >= n) {
		  setcomplex(0.0, 0.0, cm);
		}
		xfht[i] = cm;
	}
	if (t) {
		ift(xfht, n);
	}
}

void
eht(char* kind_, tcomplex** xfht, int n)
{
    TRACE("eht(...)");
	char kind[256];
	tcomplex cm;
	// char STR1[256];

	strcpy(kind, downstring(kind_));
	bool t = (kind[1] == 't');
	bool f = (kind[1] == 'f');
	bool a = (kind[1] == 'a');
	bool r = (kind[1] == 'r');
	if (!(strlen(kind) == 2 && (t || f) && (a || r))) {
		printf("use ht(s,a,n) with s=[at|rt|af|rf]\n");
		return;
	}
	if (t) {
		eft(xfht, n);
	}
	for (int i = 0; i < n; ++i) {
		if (r && i * 2 % n == 0) {
// p2c: hilbert.pas, line 63:
// * Note: Using % for possibly-negative arguments [317]
		setcomplex(0.0, 0.0, cm);
		}
		if (r && i * 2 > 0 && i * 2 < n) {
		setcomplex(getppfourierim(xfht, i), -getppfourierre(xfht, i), cm);
		}
		if (r && i * 2 > n) {
		setcomplex(-getppfourierim(xfht, i), getppfourierre(xfht, i), cm);
		}
		if (a && i * 2 % n == 0) {
// p2c: hilbert.pas, line 66:
// * Note: Using % for possibly-negative arguments [317]
		setcomplex(getppfourierre(xfht, i), getppfourierim(xfht, i), cm);
		}
		if (a && i * 2 > 0 && i * 2 < n) {
		setcomplex(2 * getppfourierre(xfht, i), 2 * getppfourierim(xfht, i),
				   cm);
		}
		if (a && i * 2 > n) {
		setcomplex(0.0, 0.0, cm);
		}
		setppfourier(xfht, i, cm.re, cm.im);
	}
	if (t) {
		eift(xfht, n);
	}
}

// End.
