// Output from p2c 1.21alpha-07.Dec.93, the Pascal-to-C translator
// $Id: mathe1.cpp,v 1.2 2004/09/01 12:45:28 micheli Exp $
// From input file "mathe1.pas"

#include <common.h>
#include <iostream>
#include <cmath>
#include <cstring>
#include <mathe1.h>

using namespace std;

double
dround(double x)
{
    // TRACE("dround(.)");
// 	if (x >= 0) {
//         double TEMP;
// 		modf(x, &TEMP);
// 		return TEMP;
// 	} else {
// 	    double TEMP1, TEMP2;
//     	modf(x, &TEMP1);
// 		modf(x, &TEMP2);
// 		return (TEMP1 + TEMP2);
// 	}
    return static_cast<double>(rint(x));
}

// typedef byte tx[4];
// typedef byte tx_[4];
//typedef byte tx__[4];

float
inf()
{
    // TRACE("inf()");
	float x;
	((byte *)(&x))[0] = 0;
	((byte *)(&x))[1] = 0;
	((byte *)(&x))[2] = 128;
	((byte *)(&x))[3] = 127;
	return x;
}

float
nan()
{
    // TRACE("nan()");
	float x;
	((byte *)(&x))[0] = 255;
	((byte *)(&x))[1] = 255;
	((byte *)(&x))[2] = 255;
	((byte *)(&x))[3] = 255;
	return x;
}

bool
isnan(float x)
{
    // TRACE("isnan(.)");
	float xx = x;

	return ((((byte *)(&xx))[0] > 0 || ((byte *)(&xx))[1] > 0 ||
			 (((byte *)(&xx))[2] & 127) > 0) &&
			(((byte *)(&xx))[2] & 128) == 128 &&
			(((byte *)(&xx))[3] & 127) == 127);
}

double
gauss(double x)
{
    // TRACE("gauss(.))");
	if (fabs(x) < 100) {
		return (exp(x * x / -2) / sqrt(2 * M_PI));
	} else {
		return 0.0;
	}
}

// double
// erf(double x)
// {
// 	if (x < 10) {
// 		double s = 0.0;
// 		double fo = 0.0;
// 		double x100 = 100 * x;
// 		int FORLIM = int(x100 + 1);
// 		for (int i = 0; i <= FORLIM; ++i) {
// 		    double TEMP = i / 100.0;
// 		    double f = exp(-TEMP * TEMP);
// 		    if (i > 0) {
// 		        s += (f + fo) * mind(1.0, x100);
// 		    }
// 		    fo = f;
// 		}
// 		return (s / sqrt(M_PI) / 100);
// 	} else {
// 		return 1.0;
// 	}
// }

double
fac(size_t n)
{
    // TRACE("fac(.)");
	double f = 1.0;
	for (size_t ii = 1; ii <= n; ++ii) {
		f *= ii;
	}

	return f;
}

// double
// gamma(double x)
// {
// 	double fo, fn;
// 
// 	if (x == int(floor(x + 0.5))) {
// 		return (fac(int(floor(x - 1 + 0.5))));
// 	} else {
// 		double fi = x;
// 		while (fi < 100) {
// 		++fi;
// 		}
// 		double f = 0.0;
// 		double t = 0.0;
// 		double dt = 10.0 / 3;
// 		t = dt / 2;
// 		do {
// 		fo = f;
// 		f += exp((fi - 1) * log(t) - t) * dt;
// 		t += dt;
// 		fn = f;
// 		} while (fo != fn);
// 		while (fi > x + 0.5) {
// 		--fi;
// 		f /= fi;
// 		}
// 		return f;
// 	}
// }

double
lngamma(double x)
{
    // TRACE("lngamma(.)");
	double DUMMY, DUMMY1;

	if (modf(x, &DUMMY) > 0) {
		double s = log(gamma(modf(x, &DUMMY1)));
		for (int i = 0; i < int(x); ++i) {
		s += log(modf(x, &DUMMY1) + i);
		}
		return s;
	}
	double s = 0.0;
	for (int i = 1; i < int(x); ++i) {
		s += log(static_cast<double>(i));
	}
	return s;
}

static double
eexp(double x)
{
    // TRACE("eexp(.)");
	if (fabs(x) < 10000) {
		return exp(x);
	} else {
		if (x > 0) {
		return (inf());
		} else {
		return 0.0;
		}
	}
}


double
chi_alpha(double alpha, int n)
{
    // TRACE("chi_alpha(.)");
	int i = 0;
	double s = 0.0;
	double s1, x1, x2, y1, y2;
	double v = n / -2.0 * log(2.0) - lngamma(n / 2.0);

	while (s < 1 - alpha) {
		x1 = i / 1000.0 * n;
		x2 = (i + 1.0) / 1000 * n;
		if (x1 > 0) {
		y1 = eexp((n / 2.0 - 1) * log(x1) - x1 / 2 + v);
		} else {
		if (n < 2) {
		y1 = inf();
		}
		if (n == 2) {
		y1 = 0.5;
		}
		if (n > 2) {
		y1 = 0.0;
		}
		}
		y2 = eexp((n / 2.0 - 1) * log(x2) - x2 / 2 + v);
		s1 = s;
		s += (y1 + y2) / 2 * (x2 - x1);
		//double s2 = s;
		++i;
	}
	double p = (y1 - (y2 - y1) / (x2 - x1) * x1) / ((y2 - y1) / (x2 - x1) / 2);
	double q = (s1 - x1 * (y1 - (y2 - y1) / (x2 - x1) * x1) +
				(y1 - y2) / (x2 - x1) / 2 * x1 * x1 - 1 + alpha) /
			   ((y2 - y1) / (x2 - x1) / 2);
	double l1 = p / -2 - sqrt(p * p / 4 - q);
	double l2 = sqrt(p * p / 4 - q) - p / 2;
	if (l1 >= x1 && l1 <= x2) {
		return l1;
	}
	if (l2 >= x1 && l2 <= x2) {
		return l2;
	}
	cout<<"Error in chi_alpha with alpha = "<<alpha<<" and n = "<<n<<endl;
	return 0;
}


double
t_alpha(double alpha, int n)
{
    // TRACE("t_alpha(..)");
	int i = 0;
	double s = 0.0;
	double s1, x1, x2, y1, y2;
	double v = lngamma((n + 1.0) / 2) - lngamma(n / 2.0) - log(sqrt(n * M_PI));

	while (s < (1 - alpha) / 2) {
		x1 = i / 1000.0 * n;
		x2 = (i + 1.0) / 1000 * n;
		y1 = exp(v - (n + 1.0) / 2 * log(1 + x1 * x1 / n));
		y2 = exp(v - (n + 1.0) / 2 * log(1 + x2 * x2 / n));
		s1 = s;
		s += (y1 + y2) / 2 * (x2 - x1);
		//double s2 = s;
		++i;
	}
	double p = (y1 - (y2 - y1) / (x2 - x1) * x1) / ((y2 - y1) / (x2 - x1) / 2);
	double q = (s1 - x1 * (y1 - (y2 - y1) / (x2 - x1) * x1) +
				(y1 - y2) / (x2 - x1) / 2 * x1 * x1 + (alpha - 1) / 2) /
			   ((y2 - y1) / (x2 - x1) / 2);
	double l1 = p / -2 - sqrt(p * p / 4 - q);
	double l2 = sqrt(p * p / 4 - q) - p / 2;
	if (l1 >= x1 && l1 <= x2) {
		return l1;
	}
	if (l2 >= x1 && l2 <= x2) {
		return l2;
	}
	cout<<"Error in t_alpha with alpha = "<<alpha<<" and n = "<<n<<endl;
	return 0.;
}


int
sgn(double x)
{
    // TRACE("sgn(.)");
    return ( x > 0 ? 1 : ( x == 0 ? 0 : -1 ) );
}


int
ggzkx(double x)
{
    // TRACE("ggzkx(.)");
	return (int(x + 1 - int(x)) + int(x) - 1);
}


double
maxd(double x1, double x2)
{
    // TRACE("");
	return ((x1 + x2 + fabs(x1 - x2)) / 2);
}


double
mind(double x1, double x2)
{
    // TRACE("mind(..)");
	return ((x1 + x2 - fabs(x1 - x2)) / 2);
}


int
maxi(double x1, double x2)
{
    // TRACE("maxi(..)");
	return (int(floor((x1 + x2 + fabs(x1 - x2)) / 2 + 0.5)));
}


int
mini(double x1, double x2)
{
    // TRACE("mini(..)");
	return (int(floor((x1 + x2 - fabs(x1 - x2)) / 2 + 0.5)));
}


double
lg(double x)
{
    // TRACE("lg(.)");
	return (log(x) / log(10.0));
}


double
ld(double x)
{
    // TRACE("ld(.)");
	return (log(x) / log(2.0));
}


double
exp10_(double x)
{
    // TRACE("exp10_(.)");
	return exp(x * log(10.0));
}


double
exp2(double x)
{
    // TRACE("exp2(.)");
	return exp(x * log(2.0));
}


double
log_(double a, double b)
{
    // TRACE("log_(..)");
	return (log(a) / log(b));
}


double
power(double a, double e)
{
    // TRACE("power(..)");
	if (a > 0) {
		return exp(e * log(a));
	} else {
		if (a == 0) {
		return 0.0;
		} else {
		return (nan());
		}
	}
}

double
tan_(double x)
{
    // TRACE("tan_(.)");
	if (cos(x) != 0) {
		return (sin(x) / cos(x));
	} else {
		return (nan());
	}
}

double
cot(double x)
{
    // TRACE("cot(.)");
	if (sin(x) != 0) {
		return (cos(x) / sin(x));
	} else {
		return (nan());
	}
}

double
sec(double x)
{
    // TRACE("sec(.)");
	if (cos(x) != 0) {
		return (1 / cos(x));
	} else {
		return (nan());
	}
}


double
csc(double x)
{
    // TRACE("csc(.)");
	if (sin(x) != 0) {
		return (1 / sin(x));
	} else {
		return (nan());
	}
}


double
arcsin_(double x)
{
    // TRACE("arcsin_(.)");
	if (x * x < 1) {
		return atan(x / sqrt(1 - x * x));
	} else {
		if (x * x == 1) {
		return (x * M_PI / 2);
		} else {
		return (nan());
		}
	}
}


double
arccos_(double x)
{
    // TRACE("arccos_(.)");
	if (x * x < 1) {
		return (M_PI / 2 - atan(x / sqrt(1 - x * x)));
	} else {
		if (x * x == 1) {
		return ((1 - x) * M_PI / 2);
		} else {
		return (nan());
		}
	}
}


double
arccot(double x)
{
    // TRACE("arccot(.)");
	return (M_PI / 2 - atan(x));
}


double
arcsec(double x)
{
    // TRACE("arcsec(.)");
	if (x * x >= 1) {
		return (M_PI * (byte)(x < 0) + sgn(x) * atan(sqrt(x * x - 1)));
	} else {
		return (nan());
	}
}


double
arccsc(double x)
{
    // TRACE("arccsc(.)");
	if (x * x > 1) {
		return (sgn(x) * atan(1 / sqrt(x * x - 1)));
	} else {
		if (x * x == 1) {
		return (x * M_PI / 2);
		} else {
		return (nan());
		}
	}
}


double
sinh_(double x)
{
    // TRACE("sinh_(.)");
	return ((exp(x) - exp(-x)) / 2);
}


double
cosh_(double x)
{
    // TRACE("cosh_(.)");
	return ((exp(x) + exp(-x)) / 2);
}


double
tanh_(double x)
{
    // TRACE("tanh_(.)");
	return (sinh_(x) / cosh_(x));
}


double
coth(double x)
{
    // TRACE("coth(.)");
	if (sinh_(x) != 0) {
		return (cosh_(x) / sinh_(x));
	} else {
		return (nan());
	}
}


double
sech(double x)
{
    // TRACE("sech(.)");
	return (1 / cosh_(x));
}


double
csch(double x)
{
    // TRACE("csch(.)");
	if (sinh_(x) != 0) {
		return (1 / sinh_(x));
	} else {
		return (nan());
	}
}


double
arsinh(double x)
{
    // TRACE("arsinh(.)");
	return log(x + sqrt(x * x + 1));
}


double
arcosh(double x)
{
    // TRACE("arcosh(.)");
	if (x >= 1) {
		return log(x + sqrt(x * x - 1));
	} else {
		return (nan());
	}
}


double
artanh(double x)
{
    // TRACE("artanh(.)");
	if (fabs(x) < 1) {
		return (log((1 + x) / (1 - x)) / 2);
	} else {
		return (nan());
	}
}


double
arcoth(double x)
{
    // TRACE("arcoth(.)");
	if (fabs(x) > 1) {
		return (log((x + 1) / (x - 1)) / 2);
	} else {
		return (nan());
	}
}


double
arsech(double x)
{
    // TRACE("arsech(.)");
	if (x > 0 && x <= 1) {
		return log((sqrt(1 - x * x) + 1) / x);
	} else {
		return (nan());
	}
}


double
arcsch(double x)
{
    // TRACE("arcsch(.)");
	if (x != 0) {
		return (log((sqrt(1 + x * x) + 1) / fabs(x)) * sgn(x));
	} else {
		return (nan());
	}
}

char *
double2string(char* Result, double ent, tfmt fmt, short dig, short kom,
			  bool posvor, bool zerofill)
{
    // TRACE("double2string(.......)");
	double tmpexp, tmpent;
	char tmpents[256], tmpvors[256];
	char STR1[256], STR2[256], STR3[256];

	switch (fmt) {

			case flt:
			case sci:
		if (ent > 0 && !posvor) {
		ent = int(floor(ent / exp10_(ggzkx(lg(fabs(ent))) - dig + 2.0) + 0.5)) *
			  exp10_(ggzkx(lg(fabs(ent))) - dig + 2.0);
		} else {
		ent = int(floor(ent / exp10_(ggzkx(lg(fabs(ent))) - dig + 3.0) + 0.5)) *
			  exp10_(ggzkx(lg(fabs(ent))) - dig + 3.0);
		}
		if (fabs(ent) > 0) {
		if (fmt == flt) {
		tmpexp = ggzkx(lg(fabs(ent)));
		}
		if (fmt == sci) {
		tmpexp = ggzkx(lg(fabs(ent)) / 3) * 3.0;
		}
		tmpent = ent / exp10_(tmpexp);
		} else {
		tmpent = 0.0;
		tmpexp = 0.0;
		}
		sprintf(Result, "%se%s",
		  double2string(STR1, tmpent, fix, dig, dig - 2, posvor, zerofill),
		  double2string(STR3, tmpexp, fix, kom, 0, false, true));

		if (!strcmp(double2string(STR1, tmpexp, fix, kom, 0, false, true),
					"E")) {
		sprintf(Result, "%se%s",
				double2string(STR3, 0.0, fix, dig, dig - 2, posvor, zerofill),
				double2string(STR2, 0.0, fix, kom, 0, false, true));
		}
		if (!strcmp(double2string(STR1, tmpexp, fix, kom, 0, false, true),
					"C") && ent > 0) {
		strcpy(Result, "C");
		}
		if (!strcmp(double2string(STR1, tmpexp, fix, kom, 0, false, true),
					"C") && ent < 0) {
		strcpy(Result, "E");
		}
		break;

			case fix:
		*tmpvors = '\0';
		if (ent < 0) {
		strcpy(tmpvors, "-");
		}
		if (ent >= 0 && posvor) {
		strcpy(tmpvors, "+");
		}
		do {
		sprintf(tmpents, "%0.*f", kom, fabs(ent));
		--kom;
		} while (sprintf(STR1, "%s%s", tmpvors, tmpents) > dig && kom != 0 &&
				 dig != 0);
		while (sprintf(STR1, "%s%s", tmpvors, tmpents) < dig) {
		if (zerofill) {
		sprintf(tmpents, "0%s", strcpy(STR3, tmpents));
		} else {
		sprintf(tmpvors, " %s", strcpy(STR2, tmpvors));
		}
		}
		sprintf(Result, "%s%s", tmpvors, tmpents);
		if (dig > 0) {
		if (ent > 0 && !posvor && int(lg(ent)) >= dig) {
		strcpy(Result, "C");
		}
		if (ent > 0 && posvor && int(lg(ent)) >= dig - 1) {
		strcpy(Result, "C");
		}
		if (ent < 0 && int(lg(-ent)) >= dig - 1) {
		strcpy(Result, "E");
		}
		}
		break;
	}
	return Result;
}

// End.
