// Output from p2c 1.21alpha-07.Dec.93, the Pascal-to-C translator
// From input file "mathe2.pas"

//#include <p2c/p2c.h>
#include <common.h>
#include <mathe1.h>
#include <mathe2.h>
#include <cstdio>
#include <cmath>
#include <iostream>

char *
complex2string(char* Result, tcomplex ent, tfmt fmt, short dig, short kom,
			   bool posvor, bool zerofill)
{
    // TRACE("complex2string(.......)");
	char STR1[256], STR2[256];

	sprintf(Result, "%s%si",
			double2string(STR1, ent.re, fmt, dig, kom, posvor, zerofill),
			double2string(STR2, ent.im, fmt, dig, kom, true, zerofill));
	return Result;
}

double
absc(tcomplex ci)
{
    // TRACE("absc(.)");
	return sqrt(ci.re * ci.re + ci.im * ci.im);
}

double
argc__(tcomplex ci)
{
    // TRACE("argc__(.)");
	if (ci.re != 0) {
		return (atan(ci.im / ci.re) + M_PI * (ci.re < 0 && ci.im >= 0) -
				M_PI * (ci.re < 0 && ci.im < 0));
	} else {
		if (ci.im != 0) {
		return (M_PI * ((ci.im > 0) - 0.5));
		} else {
		return 0.0;
		}
	}
}

void
setcomplex(double re, double im, tcomplex& c)
{
    // TRACE("setcomplex(...)");
	c.re = re;
	c.im = im;
}

void
addcc(tcomplex c1, tcomplex c2, tcomplex& c)
{
    // TRACE("addcc(...)");
	c.re = c1.re + c2.re;
	c.im = c1.im + c2.im;
}

void
subcc(tcomplex c1, tcomplex c2, tcomplex& c)
{
    // TRACE("subcc(...)");
	c.re = c1.re - c2.re;
	c.im = c1.im - c2.im;
}

void
multsc(double s, tcomplex ci, tcomplex& c)
{
    // TRACE("multsc(...)");
	c.re = s * ci.re;
	c.im = s * ci.im;
}

void
multcc(tcomplex c1, tcomplex c2, tcomplex& c)
{
    // TRACE("multcc(...)");
	c.re = c1.re * c2.re - c1.im * c2.im;
	c.im = c1.re * c2.im + c1.im * c2.re;
}

void
divcc(tcomplex c1, tcomplex c2, tcomplex& c)
{
    // TRACE("divcc(...)");
	if (c2.re * c2.re + c2.im * c2.im > 0) {
		c.re = (c1.re * c2.re + c1.im * c2.im) / (c2.re * c2.re + c2.im * c2.im);
		c.im = (c1.im * c2.re - c1.re * c2.im) / (c2.re * c2.re + c2.im * c2.im);
	} else {
		c.re = nan();
		c.im = nan();
	}
}

void
invc(tcomplex ci, tcomplex& c)
{
    // TRACE("invc(..)");
	tcomplex cc;

	cc.re = 1.0;
	cc.im = 0.0;
	divcc(cc, ci, c);
}

void
expc(tcomplex ci, tcomplex& c)
{
    // TRACE("expc(..)");
	c.re = exp(ci.re) * cos(ci.im);
	c.im = exp(ci.re) * sin(ci.im);
}

void
lnc(tcomplex ci, tcomplex& c)
{
    // TRACE("lnc(..)");
	c.re = log(absc(ci));
	c.im = argc__(ci);
}

void
sqrc(tcomplex ci, tcomplex& c)
{
    // TRACE("sqrc(..)");
	multcc(ci, ci, c);
}

void
sqrtc(tcomplex ci, tcomplex& c)
{
    // TRACE("sqrtc(..)");
	c.re = sqrt(absc(ci)) * cos(argc__(ci) / 2);
	c.im = sqrt(absc(ci)) * sin(argc__(ci) / 2);
}

void
powerc(tcomplex ci, double e, tcomplex& c)
{
    // TRACE("powerc(...)");
	c.re = power(absc(ci), e) * cos(e * argc__(ci));
	c.im = power(absc(ci), e) * sin(e * argc__(ci));
}

void
sinc(tcomplex ci, tcomplex& c)
{
    // TRACE("sinc(..)");
	c.re = sin(ci.re) * cosh_(ci.im);
	c.im = cos(ci.re) * sinh_(ci.im);
}

void
cosc(tcomplex ci, tcomplex& c)
{
    // TRACE("cosc(..)");
	c.re = cos(ci.re) * cosh_(ci.im);
	c.im = -sin(ci.re) * sinh_(ci.im);
}

void
tanc(tcomplex ci, tcomplex& c)
{
    // TRACE("tanc(..)");
	tcomplex cs, cc;

	sinc(ci, cs);
	cosc(ci, cc);
	divcc(cs, cc, c);
}

void
cotc(tcomplex ci, tcomplex& c)
{
    // TRACE("cotc(..)");
	tcomplex cs, cc;

	sinc(ci, cs);
	cosc(ci, cc);
	divcc(cc, cs, c);
}

void
secc(tcomplex ci, tcomplex& c)
{
    // TRACE("secc(..)");
	tcomplex ce, cc;

	setcomplex(1.0, 0.0, ce);
	cosc(ci, cc);
	divcc(ce, cc, c);
}

void
cscc(tcomplex ci, tcomplex& c)
{
    // TRACE("cscc(..)");
	tcomplex ce, cs;

	setcomplex(1.0, 0.0, ce);
	sinc(ci, cs);
	divcc(ce, cs, c);
}

void
arcsinc(tcomplex ci, tcomplex& c)
{
    // TRACE("arcsinc(..)");
	tcomplex ct1, ct2, ct3, ct4, ct5, ct6, ct7, ct8, ct9;

	sqrc(ci, ct1);
	setcomplex(1.0, 0.0, ct2);
	subcc(ct2, ct1, ct3);
	sqrtc(ct3, ct4);
	setcomplex(0.0, 1.0, ct5);
	multcc(ct5, ci, ct6);
	addcc(ct6, ct4, ct7);
	lnc(ct7, ct8);
	setcomplex(0.0, -1.0, ct9);
	multcc(ct9, ct8, c);
}

void
arccosc(tcomplex ci, tcomplex& c)
{
    // TRACE("arccosc(..)");
	tcomplex ct1, ct2, ct3, ct4, ct5, ct6, ct7, ct8, ct9;

	sqrc(ci, ct1);
	setcomplex(1.0, 0.0, ct2);
	subcc(ct2, ct1, ct3);
	sqrtc(ct3, ct4);
	setcomplex(0.0, 1.0, ct5);
	multcc(ct5, ct4, ct6);
	addcc(ci, ct6, ct7);
	lnc(ct7, ct8);
	setcomplex(0.0, -1.0, ct9);
	multcc(ct9, ct8, c);
}

void
arctanc(tcomplex ci, tcomplex& c)
{
    // TRACE("arctanc(..)");
	tcomplex ct1, ct2, ct3, ct4, ct5, ct6, ct7, ct8;

	setcomplex(0.0, 1.0, ct1);
	multcc(ct1, ci, ct2);
	setcomplex(1.0, 0.0, ct3);
	addcc(ct3, ct2, ct4);
	subcc(ct3, ct2, ct5);
	divcc(ct4, ct5, ct6);
	lnc(ct6, ct7);
	multcc(ct1, ct7, ct8);
	multsc(-0.5, ct8, c);
}

void
arccotc(tcomplex ci, tcomplex& c)
{
    // TRACE("arccotc(..)");
	tcomplex ct1, ct2, ct3, ct4, ct5, ct6, ct7, ct8;

	setcomplex(0.0, 1.0, ct1);
	multcc(ct1, ci, ct2);
	setcomplex(1.0, 0.0, ct3);
	subcc(ct2, ct3, ct4);
	addcc(ct2, ct3, ct5);
	divcc(ct4, ct5, ct6);
	lnc(ct6, ct7);
	multcc(ct1, ct7, ct8);
	multsc(-0.5, ct8, c);
}

void
arcsecc(tcomplex ci, tcomplex& c)
{
    // TRACE("arcsecc(..)");
	tcomplex ct1, ct2;

	setcomplex(1.0, 0.0, ct1);
	divcc(ct1, ci, ct2);
	arccosc(ct2, c);
}

void
arccscc(tcomplex ci, tcomplex& c)
{
    // TRACE("arccscc(..)");
	tcomplex ct1, ct2;

	setcomplex(1.0, 0.0, ct1);
	divcc(ct1, ci, ct2);
	arcsinc(ct2, c);
}

void
sinhc(tcomplex ci, tcomplex& c)
{
    // TRACE("sinhc(..)");
	c.re = sinh_(ci.re) * cos(ci.im);
	c.im = cosh_(ci.re) * sin(ci.im);
}

void
coshc(tcomplex ci, tcomplex& c)
{
    // TRACE("coshc(..)");
	c.re = cosh_(ci.re) * cos(ci.im);
	c.im = sinh_(ci.re) * sin(ci.im);
}

void
tanhc(tcomplex ci, tcomplex& c)
{
    // TRACE("tanhc(..)");
	tcomplex cs, cc;

	sinhc(ci, cs);
	coshc(ci, cc);
	divcc(cs, cc, c);
}

void
cothc(tcomplex ci, tcomplex& c)
{
    // TRACE("cothc(..)");
	tcomplex cs, cc;

	sinhc(ci, cs);
	coshc(ci, cc);
	divcc(cc, cs, c);
}

void
sechc(tcomplex ci, tcomplex& c)
{
    // TRACE("sechc(..)");
	tcomplex ce, cc;

	setcomplex(1.0, 0.0, ce);
	coshc(ci, cc);
	divcc(ce, cc, c);
}

void
cschc(tcomplex ci, tcomplex& c)
{
    // TRACE("cschc(..)");
	tcomplex ce, cs;

	setcomplex(1.0, 0.0, ce);
	sinhc(ci, cs);
	divcc(ce, cs, c);
}

void
arsinhc(tcomplex ci, tcomplex& c)
{
    // TRACE("arsinhc(..)");
	tcomplex ct1, ct2, ct3, ct4, ct5;

	sqrc(ci, ct1);
	setcomplex(1.0, 0.0, ct2);
	addcc(ct1, ct2, ct3);
	sqrtc(ct3, ct4);
	addcc(ci, ct4, ct5);
	lnc(ct5, c);
}

void
arcoshc(tcomplex ci, tcomplex& c)
{
    // TRACE("arcoshc(..)");
	tcomplex ct1, ct2, ct3, ct4, ct5;

	sqrc(ci, ct1);
	setcomplex(1.0, 0.0, ct2);
	subcc(ct1, ct2, ct3);
	sqrtc(ct3, ct4);
	subcc(ci, ct4, ct5);
	lnc(ct5, c);
}

void
artanhc(tcomplex ci, tcomplex& c)
{
    // TRACE("artanhc(..)");
	tcomplex ct1, ct2, ct3, ct4, ct5;

	setcomplex(1.0, 0.0, ct1);
	addcc(ct1, ci, ct2);
	subcc(ct1, ci, ct3);
	divcc(ct2, ct3, ct4);
	lnc(ct4, ct5);
	multsc(0.5, ct5, c);
}

void
arcothc(tcomplex ci, tcomplex& c)
{
    // TRACE("arcothc(..)");
	tcomplex ct1, ct2, ct3, ct4, ct5;

	setcomplex(1.0, 0.0, ct1);
	addcc(ci, ct1, ct2);
	subcc(ci, ct1, ct3);
	divcc(ct2, ct3, ct4);
	lnc(ct4, ct5);
	multsc(0.5, ct5, c);
}

void
arsechc(tcomplex ci, tcomplex& c)
{
    // TRACE("arsechc(..)");
	tcomplex ct1, ct2;

	setcomplex(1.0, 0.0, ct1);
	divcc(ct1, ci, ct2);
	arcoshc(ct2, c);
}

void
arcschc(tcomplex ci, tcomplex& c)
{
    // TRACE("arcschc(..)");
	tcomplex ct1, ct2;

	setcomplex(1.0, 0.0, ct1);
	divcc(ct1, ci, ct2);
	arsinhc(ct2, c);
}

// End.
