// Output from p2c 1.21alpha-07.Dec.93, the Pascal-to-C translator
// $Id: mathe4.cpp,v 1.1.1.1 2003/03/25 12:00:31 micheli Exp $
// From input file "mathe4.pas"
#include <mathe1.h>
#include <mathe2.h>
#include <mathe4.h>
#include <cmath>
#include <iostream>

void
getppfouriermem(tcomplex** xfft, size_t n)
{
    TRACE("getppfouriermem(..)");
	xfft = new tcomplex*[(n / mfourier + 1)];
	for (size_t i = 0; i < n / mfourier; ++i) {
		xfft[i] = new tcomplex[mfourier];
	}
	xfft[n / mfourier] = new tcomplex[n % mfourier];
}

void
freeppfouriermem(tcomplex** xfft, size_t n)
{
    TRACE("freeppfouriermem(..)");
	delete [] xfft[n / mfourier];
	for (size_t i = 0; i < n / mfourier; ++i) {
		delete [] xfft[i];
	}
	delete [] xfft;
}

void
setppfourierre(tcomplex** xfft, size_t n, double v)
{
    TRACE("setppfourierre(...)");
	xfft[n / mfourier][n % mfourier].re = v;
}

void
setppfourierim(tcomplex** xfft, size_t n, double v)
{
    TRACE("setppfourierim(...)");
	xfft[n / mfourier][n % mfourier].im = v;
}

void
setppfourier(tcomplex** xfft, size_t n, double re, double im)
{
    TRACE("setppfourier(....)");
	xfft[n / mfourier][n % mfourier].re = re;
	xfft[n / mfourier][n % mfourier].im = im;
}

void
incppfourierre(tcomplex** xfft, size_t n, double v)
{
    TRACE("incppfourierre(...)");
	xfft[n / mfourier][n % mfourier].re += v;
}

void
incppfourierim(tcomplex** xfft, size_t n, double v)
{
    TRACE("incppfourierim(...)");
	xfft[n / mfourier][n % mfourier].im += v;
}

void
incppfourier(tcomplex** xfft, size_t n, double re, double im)
{
    TRACE("incppfourier(....)");
	xfft[n / mfourier][n % mfourier].re += re;
	xfft[n / mfourier][n % mfourier].im += im;
}

double
getppfourierre(tcomplex** xfft, size_t n)
{
    TRACE("getppfourierre(..)");
	return (xfft[n / mfourier][n % mfourier].re);
}

double
getppfourierim(tcomplex** xfft, size_t n)
{
    TRACE("getppfourierim(..)");
	return (xfft[n / mfourier][n % mfourier].im);
}

void
getppbytemem(byte** xfft, size_t n)
{
    TRACE("getppbytemem(..)");
	xfft = new byte*[(n / mbyte + 1)];
	for (size_t i = 0; i < n / mbyte; ++i) {
		xfft[i] = new byte[mbyte];
	}
	xfft[n / mbyte] = new byte[n % mbyte];
}

void
freeppbytemem(byte** xfft, size_t n)
{
    TRACE("freeppbytemem(..)");
	delete [] xfft[n / mbyte];
	for (size_t i = 0; i < n / mbyte; ++i) {
		delete [] xfft[i];
	}
	delete [] xfft;
}

void
getppsinglemem(float** xfft, size_t n)
{
    TRACE("getppsinglemem(..)");
	xfft = new float*[(n / msingle + 1)];
	for (size_t i = 0; i < n / msingle; ++i) {
		xfft[i] = new float[msingle];
	}
	xfft[n / msingle] = new float[n % msingle];
}

void
freeppsinglemem(float** xfft, size_t n)
{
    TRACE("freeppsinglemem(..)");
	delete [] xfft[n / msingle];
	for (size_t i = 0; i < n / msingle; ++i) {
		delete [] xfft[i];
	}
	delete [] xfft;
}

void
getpplinearmem(double** xfft, size_t n)
{
    TRACE("getpplinearmem(..)");
	xfft = new double*[(n / mlinear + 1)];
	for (size_t i = 0; i < n / mlinear; ++i) {
		xfft[i] = new double[mlinear];
	}
	xfft[n / mlinear] = new double[n % mlinear];
}

void
freepplinearmem(double** xfft, size_t n)
{
    TRACE("freepplinearmem(..)");
	delete [] xfft[n / mlinear];
	for (size_t i = 0; i < n / mlinear; ++i) {
		delete [] xfft[i];
	}
	delete [] xfft;
}

void
setppbyte(byte** xfft, size_t n, byte v)
{
    TRACE("setppbyte(...)");
	xfft[n / mbyte][n % mbyte] = v;
}

void
incppbyte(byte** xfft, size_t n, byte v)
{
    TRACE("incppbyte(...)");
	xfft[n / mbyte][n % mbyte] += v;
}

byte
getppbyte(byte** xfft, size_t n)
{
    TRACE("getppbyte(...)");
	return (xfft[n / mbyte][n % mbyte]);
}

void
setppsingle(float** xfft, size_t n, double v)
{
    TRACE("setppsingle(...)");
	xfft[n / msingle][n % msingle] = v;
}

void
incppsingle(float** xfft, size_t n, double v)
{
    TRACE("incppsingle(...)");
	xfft[n / msingle][n % msingle] += v;
}

double
getppsingle(float** xfft, size_t n)
{
    TRACE("getppsingle(..)");
	return (xfft[n / msingle][n % msingle]);
}

void
setpplinear(double** xfft, size_t n, double v)
{
    TRACE("setpplinear(...)");
	xfft[n / mlinear][n % mlinear] = v;
}

void
incpplinear(double** xfft, size_t n, double v)
{
    TRACE("incpplinear(...)");
	xfft[n / mlinear][n % mlinear] += v;
}

double
getpplinear(double** xfft, size_t n)
{
    TRACE("getpplinear(..)");
	return (xfft[n / mlinear][n % mlinear]);
}

void
solve_ext(double* m, double* eq, double* wur, size_t n)
{
    TRACE("solve_ext(....)");
	double* mo = new double[n * n];
	invm_ext(m, mo, n);
	for (size_t z = 0; z < n; ++z) {
		wur[z] = 0.0;
		for (size_t s = 0; s < n; ++s) {
		wur[z] += eq[s] * mo[n * z + s];
		}
	}
	delete [] mo;
}

void
invm_ext(double* m, double* mo, size_t n)
{
    TRACE("invm_ext(...)");
	double* mi = new double[n * n];
	for (size_t z = 0; z < n; ++z) {
		for (size_t s = 0; s < n; ++s) {
		mi[n * z + s] = m[n * z + s];
		}
	}
	for (size_t z = 0; z < n; ++z) {
		for (size_t s = 0; s < n; ++s) {
		mo[n * z + s] = (byte)(z == s);
		}
	}
	for (size_t s = 0; s < n; ++s) {
		double fac = 1 / mi[n * s + s];
		for (size_t i = 0; i < n; ++i) {
		mi[n * s + i] *= fac;
		}
		for (size_t i = 0; i < n; ++i) {
		mo[n * s + i] *= fac;
		}
		for (size_t z = s + 1; z < n; ++z) {
		fac = -mi[n * z + s];
		for (size_t i = 0; i < n; ++i) {
		mi[n * z + i] += mi[n * s + i] * fac;
		}
		for (size_t i = 0; i < n; ++i) {
		mo[n * z + i] += mo[n * s + i] * fac;
		}
		}
	}
	for (size_t s = n - 1; s >= 0; --s) {
		double fac = 1 / mi[n * s + s];
		for (size_t i = 0; i < n; ++i) {
		mi[n * s + i] *= fac;
		}
		for (size_t i = 0; i < n; ++i) {
		mo[n * s + i] *= fac;
		}
		for (size_t z = s - 1; z >= 0; --z) {
		fac = -mi[n * z + s];
		for (size_t i = 0; i < n; ++i) {
		mi[n * z + i] += mi[n * s + i] * fac;
		}
		for (size_t i = 0; i < n; ++i) {
		mo[n * z + i] += mo[n * s + i] * fac;
		}
		}
	}
	delete [] mi;
}

void
mulm_ext(double* m1, double* m2, double* mo, size_t n)
{
    TRACE("mulm_ext(....)");
	for (size_t z = 0; z < n; ++z) {
		for (size_t s = 0; s < n; ++s) {
		mo[n * z + s] = 0.0;
		for (size_t i = 0; i < n; ++i) {
		mo[n * z + s] += m1[n * z + i] * m2[n * i + s];
		}
		}
	}
}

void
dreisqrtm_ext(double* m, double* mo, size_t n)
{
    TRACE("dreisqrtm_ext(...)");
	for (size_t s = 0; s < n; ++s) {
		mo[n * s + s] = m[n * s + s];
		for (size_t s1 = 0; s1 < s; ++s1) {
    		double TEMP = mo[n * s + s1];
	    	mo[n * s + s] -= TEMP * TEMP;
		}
		mo[n * s + s] = sqrt(fabs(mo[n * s + s]));
		for (size_t z = 0; z < s; ++z) {
    		mo[n * z + s] = 0.0;
		}
		for (size_t z = s + 1; z < n; ++z) {
	    	mo[n * z + s] = m[n * z + s];
		for (size_t s1 = 0; s1 < s; ++s1) {
		    mo[n * z + s] -= mo[n * z + s1] * mo[n * s + s1];
		}
		mo[n * z + s] /= mo[n * s + s];
		}
	}
}

void
solve_eext(double** m, double* eq, double* wur, size_t n)
{
    TRACE("solve_eext(....)");
	double** mo;
	getpplinearmem(mo, n * n);
	invm_eext(m, mo, n);
	for (size_t z = 0; z < n; ++z) {
		wur[z] = 0.0;
		for (size_t s = 0; s < n; ++s) {
    		wur[z] += eq[s] * getpplinear(mo, n * z + s);
		}
	}
	freepplinearmem(mo, n * n);
}

void
invm_eext(double** m, double** mo, size_t n)
{
    TRACE("invm_eext(...)");
	double** mi;
	getpplinearmem(mi, n * n);
	for (size_t z = 0; z < n; ++z) {
		for (size_t s = 0; s < n; ++s) {
    		setpplinear(mi, n * z + s, getpplinear(m, n * z + s));
		}
	}
	for (size_t z = 0; z < n; ++z) {
		for (size_t s = 0; s < n; ++s) {
	    	setpplinear(mo, n * z + s, (byte)(z == s));
		}
	}
	for (size_t s = 0; s < n; ++s) {
		double fac = 1 / getpplinear(mi, n * s + s);
		for (size_t i = 0; i < n; ++i) {
    		setpplinear(mi, n * s + i, getpplinear(mi, n * s + i) * fac);
		}
		for (size_t i = 0; i < n; ++i) {
	    	setpplinear(mo, n * s + i, getpplinear(mo, n * s + i) * fac);
		}
		for (size_t z = s + 1; z < n; ++z) {
		fac = -getpplinear(mi, n * z + s);
		for (size_t i = 0; i < n; ++i) {
    		incpplinear(mi, n * z + i, getpplinear(mi, n * s + i) * fac);
		}
		for (size_t i = 0; i < n; ++i) {
    		incpplinear(mo, n * z + i, getpplinear(mo, n * s + i) * fac);
		}
		}
	}
	for (size_t s = n - 1; s >= 0; --s) {
		double fac = 1 / getpplinear(mi, n * s + s);
		for (size_t i = 0; i < n; ++i) {
    		setpplinear(mi, n * s + i, getpplinear(mi, n * s + i) * fac);
		}
		for (size_t i = 0; i < n; ++i) {
	    	setpplinear(mo, n * s + i, getpplinear(mo, n * s + i) * fac);
		}
		for (size_t z = s - 1; z >= 0; --z) {
		    fac = -getpplinear(mi, n * z + s);
		for (size_t i = 0; i < n; ++i) {
    		incpplinear(mi, n * z + i, getpplinear(mi, n * s + i) * fac);
		}
		for (size_t i = 0; i < n; ++i) {
	    	incpplinear(mo, n * z + i, getpplinear(mo, n * s + i) * fac);
		}
		}
	}
	freepplinearmem(mi, n * n);
}

static double
hh(double x, size_t n)
{
    TRACE("hh(..)");
	if (x != 0) {
		return (x / fabs(x) * exp(n * log(fabs(x))));
	} else {
		return 0.0;
	}
}

void
regression(size_t n, double* x, double* y, size_t grad, double* para)
{
    TRACE("regression(.....)");
	double* m = new double[(grad + 1) * (grad + 1)];
	double* eq = new double[(grad + 1)];
	for (size_t j = 0; j <= grad; ++j) {
		for (size_t k = 0; k <= grad; ++k) {
		m[j * (grad + 1) + k] = 0.0;
		}
	}
	for (size_t j = 0; j <= grad; ++j) {
		for (size_t k = 0; k <= grad; ++k) {
		for (size_t i = 0; i < n; ++i) {
		m[j * (grad + 1) + k] += hh(x[i], j + k);
		}
		}
	}
	for (size_t j = 0; j <= grad; ++j) {
		eq[j] = 0.0;
	}
	for (size_t j = 0; j <= grad; ++j) {
		for (size_t i = 0; i < n; ++i) {
		eq[j] += hh(x[i], j) * y[i];
		}
	}
	solve_ext(m, eq, para, grad + 1);
	delete [] m;
	delete [] eq;
}
// End.
