// Output from p2c 1.21alpha-07.Dec.93, the Pascal-to-C translator
// $Id: sfu.cpp,v 1.1.1.1 2003/03/25 12:00:31 micheli Exp $
// From input file "sfu.pas"

#include <sfu.h>
#include <mathe1.h>
#include <mathe2.h>
#include <cmath>
#include <iostream>

int
get_prim_freq(byte st)
{
    TRACE("get_prim_freq(.)");
	int Result;

	switch (st) {
        case 1:
            Result = 20000;
            break;
        case 2:
            Result = 20000;
            break;
        case 3:
            Result = 20000;
            break;
        case 4:
            Result = 20000;
            break;
        case 5:
            Result = 20000;
            break;
	}
	return Result;
}

int
getp(byte st)
{
    TRACE("getp(.)");
	int Result;

	switch (st) {
        case 1:
            Result = 0;
            break;
        case 2:
            Result = 0;
            break;
        case 3:
            Result = 0;
            break;
        case 4:
            Result = 0;
            break;
        case 5:
            Result = 2;
            break;
	}
	return Result;
}

int
getq(byte st)
{
    TRACE("getq(.)");
	int Result;

	switch (st) {
        case 1:
            Result = 249;
            break;
        case 2:
            Result = 299;
            break;
        case 3:
            Result = 2499;
            break;
        case 4:
            Result = 2499;
            break;
        case 5:
            Result = 0;
            break;
	}
	return Result;
}

static double
armaf(double f)
{
    TRACE("armaf(.)");
	tcomplex z, n;

	z.re = 0.0;
	z.im = 0.0;
	n.re = 0.0;
	n.im = 0.0;

	z.re += bb0 * cos(0.0 * f);
	z.im += bb0 * sin(0.0 * f);

	n.re += aa0 * cos(0.0 * f);
	n.im += aa0 * sin(0.0 * f);
	n.re += aa1 * cos(2 * M_PI * f);
	n.im += aa1 * sin(2 * M_PI * f);
	n.re += aa2 * cos(2 * M_PI * 2 * f);
	n.im += aa2 * sin(2 * M_PI * 2 * f);

	if (n.re * n.re + n.im * n.im > 0) {
		return ((z.re * z.re + z.im * z.im) / (n.re * n.re + n.im * n.im));
	} else {
		return 0.0;
	}
}

#define fc              300
#define f1              100
#define f2              1000
double
sf(double f, byte st)
{
    //TRACE("sf(.,"<<static_cast<int>(st)<<')');
	double Result, TEMP, TEMP1;
    Result=0.;
	switch (st) {
        case 1:
            if (f < fc) {
                Result = 1.0;
            } else {
                Result = 0.0;
            }
            break;

        case 2:
            Result = power(2.0, -(f / fc));
            break;

        case 3:
            Result = 1 / (1 + power(f / f1, 5.0 / 3)) 
                       / (1 + power(f / f2, 7 - 5.0 / 3));
            break;

        case 4:
            TEMP = f - f1;
            TEMP1 = f - f2;
            Result =
            (1 + 10 * exp(TEMP * TEMP / -10) + 10 * exp(TEMP1 * TEMP1 / -10000)) /
            (1 + power(f / f1, 5.0 / 3)) / (1 + power(f / f2, 7 - 5.0 / 3));
            break;

        case 5:
            Result = armaf(f / get_prim_freq(st)) / get_prim_freq(st);
            break;
	}
	return Result;
}

#undef fc
#undef f1
#undef f2

void 
_sfu_init()
{
    TRACE("_sfu_init()");
	static int _was_initialized = 0;
	if (_was_initialized++)
	return;
}
// p2c: Note: Remember to call _sfu_init() in main program [215]




// End.
